
//const Ci = Components.interfaces;
//const Cc = Components.classes;
//const Cu = Components.utils;

Cu.import("resource://asterisk-ext/asteriskext.js");

/******************************************************************************/
/* AsteriskExtChrome Namespace                                                */
/******************************************************************************/

if ("undefined" == typeof(AsteriskExtChrome)) {
	var AsteriskExtChrome = {

/******************************************************************************/
/* Global Vars                                                                */
/******************************************************************************/

		numberRegEx: /(\+[0-9]{1,3})?[^+]?([0-9]+[^+]{0,2})+[0-9]+/ ,

		prefsListener: null,
		manager: null,

		ps: Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch),
		
		loglevel: 1,

/******************************************************************************/
/* Browser Functions                                                          */
/******************************************************************************/

		BrowserOverlay: {

			// entry point
			load: function (event) {
				AsteriskExtChrome.loglevel = AsteriskExtChrome.ps.getIntPref("extensions.asterisk.loglevel");
				AsteriskExtChrome.stringBundle = document.getElementById('asterisk-ext-strings');
				AsteriskExt.logmessage(2, "BROWSER LOAD");
				AsteriskExtChrome.updatePrefs();

				document.getElementById("asterisk-ext-status-icon").setAttribute("hidden", 
					!AsteriskExtChrome.ps.getBoolPref("extensions.asterisk.statusicon") );
				document.getElementById("asterisk-ext-status-textbox").setAttribute("hidden", 
					!AsteriskExtChrome.ps.getBoolPref("extensions.asterisk.statustextbox") );


				AsteriskExtChrome.prefsListener = new AsteriskExtChrome.PrefListener("extensions.asterisk.",
					function(branch, name)
					{
						switch (name)
						{
							case "statusicon":
								document.getElementById("asterisk-ext-status-icon").setAttribute("hidden", !branch.getBoolPref(name));
								break;
							case "statustextbox":
								document.getElementById("asterisk-ext-status-textbox").setAttribute("hidden", !branch.getBoolPref(name));
								break;
						}
					});
				AsteriskExtChrome.prefsListener.register();

				AsteriskExt.CallObserver.register();
				AsteriskExtChrome.CallObserver.register();
				
				/******************************************************************************/
				/* Manager instanciation                                                      */
				/******************************************************************************/

				if( AsteriskExtChrome.ps.getBoolPref("extensions.asterisk.manager") )
				{
					AsteriskExt.logmessage(2, "Init. Using AMI");
					AsteriskExtChrome.manager = AsteriskExt.AsteriskAMI;
				}
				else
				{
					AsteriskExt.logmessage(2, "Init. Using AJAM");
					AsteriskExtChrome.manager = AsteriskExt.AsteriskAJAM;
				}

				/******************************************************************************/
				/* Init                                                                       */
				/******************************************************************************/

				try
				{
					if( AsteriskExtChrome.ps.getBoolPref("extensions.asterisk.manager")  )
					{
						if( AsteriskExtChrome.ps.getBoolPref("extensions.asterisk.autoconnect") )
						{
							AsteriskExtChrome.connectManager();
						}
					}
					else
					{
						AsteriskExtChrome.connectManager();
					}

				}
				catch(e)
				{
					AsteriskExt.logmessage(1, e);
				}

	
				var parsedocument = AsteriskExtChrome.ps.getBoolPref("extensions.asterisk.parsedocument");
				if( !parsedocument )
				{
					// firefox
				   	if(document.getElementById("contentAreaContextMenu"))
				   	{
				   		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", AsteriskExtChrome.BrowserOverlay.onContentAreaContextMenu, true);
				   	}
				   	// thunderbird
					if(document.getElementById("messagePaneContext"))
					{
				   		document.getElementById("messagePaneContext").addEventListener("popupshowing", AsteriskExtChrome.BrowserOverlay.onContentAreaContextMenu, true);
				   	}
					return;
				}
	

			//	var frame=null;
				// auto load for Firefox
			/*	frame = window.document.getElementById("appcontent");
				if( frame )
				{
					frame.addEventListener("DOMContentLoaded",parseDOM,false);
					//frame.addEventListener("DOMFrameContentLoaded",parseDOM,false);
				}
			*/
				// auto load for Thunderbird
			/*	frame = document.getElementById("messagepane");
				if( frame )
				{
					frame.addEventListener("DOMContentLoaded",parseDOM,false);
					//frame.addEventListener("DOMFrameContentLoaded",parseDOM,false);
				}
			*/

			},

			dial: function(number)
			{
					AsteriskExtChrome.dial(number);
			},


			confirmDial: function(number)
			{
				if( number.length == 0 ) return;
				var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
					.getService(Components.interfaces.nsIPromptService);
				var result = prompts.confirm(window, "Asterisk Click2Dial", AsteriskExtChrome.stringBundle.getString("menu_call")+" "+number+" ?");
				if( result )
				{
					AsteriskExtChrome.dial(number);
				}
			},

			editConfirmDial: function(number)
			{
				if( number.length == 0 ) return;
				var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
					.getService(Components.interfaces.nsIPromptService);
				var input = {value: number};
				var check = {value: false};
				result = prompts.prompt(window, "Asterisk Click2Dial", AsteriskExtChrome.stringBundle.getString("menu_call")+" ", input, null, check);
				if( result )
				{
					AsteriskExtChrome.dial(input.value);
				}
			},


/*******************************************************************************
 * On Event functions
 ******************************************************************************/

			onContentAreaContextMenu: function()
			{
				var selection = getBrowserSelection();
				if( selection )
				{
					var number = AsteriskExtChrome.cleanPhoneNumber(selection);
					if( number.length > 0 )
					{
						document.getElementById("context-asterisk").label = AsteriskExtChrome.stringBundle.getString("menu_call")+" "+number;
						document.getElementById("context-asterisk").value = number;
						document.getElementById("context-asterisk-edit").label = AsteriskExtChrome.stringBundle.getString("menu_editcall")+" "+number;
						document.getElementById("context-asterisk-edit").value = number;
						document.getElementById("context-asterisk").hidden = false;
						document.getElementById("context-asterisk-edit").hidden = false;
					}
					else
					{
						document.getElementById("context-asterisk").hidden = true;
						document.getElementById("context-asterisk-edit").hidden = true;
					}
				}
				else
				{
					document.getElementById("context-asterisk").hidden = true;
					document.getElementById("context-asterisk-edit").hidden = true;
				}
			},

			statusDial: function()
			{
				var text = document.getElementById("asterisk-ext-status-textbox");
				AsteriskExtChrome.dial(AsteriskExtChrome.cleanPhoneNumber(text.value));
			},

			onStatusButtonMouseDown: function()
			{
				var popup = document.getElementById('asterisk-ext-popup');
				var panel = document.getElementById("asterisk-ext-statusbarpanel");

				if (popup.parentNode != panel)
					panel.appendChild(popup);

				popup.openPopup(panel, "before_start", 0, 0, true);
			},

			showStatusBarContextMenu: function()
			{
			},

			onStatusBarContextMenu: function(event)
			{
				var skipclipboard = false;
				var clip = Cc["@mozilla.org/widget/clipboard;1"].createInstance(Ci.nsIClipboard);
				if (clip)
				{
					var trans = Cc["@mozilla.org/widget/transferable;1"].createInstance(Ci.nsITransferable);
					if (trans)
					{
						trans.addDataFlavor("text/unicode");
						clip.getData(trans,clip.kGlobalClipboard);
						var str=new Object();
						var strLength=new Object();
						try
						{
							trans.getTransferData("text/unicode",str,strLength);
						}
						catch(e)
						{
							skipclipboard = true;
						}
						if (!skipclipboard) 
						{
							str=str.value.QueryInterface(Ci.nsISupportsString);
							// ""+str needed to convert this into a string object
							var number = AsteriskExtChrome.cleanPhoneNumber(""+str);
							if( number.length > 0 )
							{
								document.getElementById("asterisk-ext-call-menuitem").label = AsteriskExtChrome.stringBundle.getString("menu_call")+" "+number;
								document.getElementById("asterisk-ext-call-menuitem").value = number;
								document.getElementById("asterisk-ext-call-menuitem").hidden = false;
							}
							else
							{
								skipclipboard = true;
								document.getElementById("asterisk-ext-call-menuitem").hidden = true;
							}
						}
					}
					else
					{
						skipclipboard = true;
					}
				}
				else
				{
					skipclipboard = true;
				}
	
				if(skipclipboard)
				{
					// Firefox function : getBrowserSelection
					var selection = getBrowserSelection();
					if( selection )
					{
						var number = AsteriskExtChrome.cleanPhoneNumber(selection);
						if( number.length > 0 )
						{
							document.getElementById("asterisk-ext-call-menuitem").label = AsteriskExtChrome.stringBundle.getString("menu_call")+" "+number;
							document.getElementById("asterisk-ext-call-menuitem").value = number;
							document.getElementById("asterisk-ext-call-menuitem").hidden = false;
						}
						else
						{
							document.getElementById("asterisk-ext-call-menuitem").hidden = true;
						}
					}
					else
					{
						document.getElementById("asterisk-ext-call-menuitem").hidden = true;
					}
				}


				if( AsteriskExtChrome.manager.requireConnection() )
				{
					if ( AsteriskExtChrome.manager.isLoggedIn() )
					{
						document.getElementById("asterisk-ext-connect-menuitem").hidden = true;
						document.getElementById("asterisk-ext-disconnect-menuitem").hidden = false;
					}
					else 
					{
						document.getElementById("asterisk-ext-connect-menuitem").hidden = false;
						document.getElementById("asterisk-ext-disconnect-menuitem").hidden = true;
					}
				}
				else
				{
					document.getElementById("asterisk-ext-connect-menuitem").hidden = true;
					document.getElementById("asterisk-ext-disconnect-menuitem").hidden = true;
				}
			},

			/*******************************************************************************
			 * Open new Windows
			 ******************************************************************************/

			openOptionsWindow: function()
			{
				var windows = Components.classes['@mozilla.org/appshell/window-mediator;1']
					.getService(Components.interfaces.nsIWindowMediator)
					.getEnumerator(null);
				while (windows.hasMoreElements())
				{
					var win = windows.getNext();
					if (win.document.documentURI == "chrome://asterisk-ext/content/options.xul")
					{
						win.focus();
						return;
					}
				}
				window.openDialog("chrome://asterisk-ext/content/options.xul",
					"AsteriskExtPreferences",
					"chrome,titlebar,toolbar,centerscreen,modal",
					null);  
			},

			openAboutWindow: function()
			{
				var windows = Components.classes['@mozilla.org/appshell/window-mediator;1']
					.getService(Components.interfaces.nsIWindowMediator)
					.getEnumerator(null);
				while (windows.hasMoreElements())
				{
					var win = windows.getNext();
					if (win.document.documentURI == "chrome://asterisk-ext/content/about.xul")
					{
						win.focus();
						return;
					}
				}
				window.openDialog(
					"chrome://asterisk-ext/content/about.xul", 
					"AsteriskExtAbout",
					"chrome,centerscreen,modal",
					null);  
			},


		},
		
		/******************************************************************************/
		/* Observers                                                                  */
		/******************************************************************************/

		PrefListener: function(branchName, func)
		{
			var prefService = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService);
			var branch = prefService.getBranch(branchName);
			branch.QueryInterface(Components.interfaces.nsIPrefBranch2);

			this.register = function()
			{
				branch.addObserver("", this, false);
				branch.getChildList("", { })
					.forEach(function (name) { func(branch, name); });
			};

			this.unregister = function()
			{
				if (branch)
					branch.removeObserver("", this);
			};

			this.observe = function(subject, topic, data)
			{
				if (topic == "nsPref:changed")
					func(branch, data);
			};
		},


		CallObserver: {
			stringBundle: null,

			QueryInterface: function (aIID) {
				if (aIID.equals(Ci.nsIObserver) ||
						aIID.equals(Ci.nsISupports) ||
						aIID.equals(Ci.nsISupportsWeakReference))
					return this;
				throw Components.results.NS_NOINTERFACE;
			},

			observe: function(subject, topic, data)
			{
				switch(topic)
				{
					case "asterisk-ext-error":
						AsteriskExt.logmessage(3, "gui received ERROR");
						document.getElementById("asterisk-ext-status-icon").setAttribute("class", "nok");
						break;
					case "asterisk-ext-loggedin":
						AsteriskExt.logmessage(3, "gui received LOGGEDIN");
						document.getElementById("asterisk-ext-status-icon").setAttribute("class", "ok");
						break;
					case "asterisk-ext-loggedout":
						AsteriskExt.logmessage(3, "gui received LOGGEDOUT");
						document.getElementById("asterisk-ext-status-icon").removeAttribute("class");
						break;
					case "asterisk-ext-close":
						AsteriskExt.logmessage(3, "gui received CLOSE");
						break;
				}
			},
	
			register: function()
			{
				var obsService = Cc["@mozilla.org/observer-service;1"]
					.getService(Ci.nsIObserverService);
				obsService.addObserver(this, "asterisk-ext-error", true);
				obsService.addObserver(this, "asterisk-ext-loggedin", true);
				obsService.addObserver(this, "asterisk-ext-loggedout", true);
				obsService.addObserver(this, "asterisk-ext-close", true);
			},

			unregister: function()
			{
				var obsService = Cc["@mozilla.org/observer-service;1"]
					.getService(Ci.nsIObserverService);
				try {
					obsService.removeObserver(this, "asterisk-ext-error");
					obsService.removeObserver(this, "asterisk-ext-loggedin");
					obsService.removeObserver(this, "asterisk-ext-loggedout");
					obsService.removeObserver(this, "asterisk-ext-close");
				} catch(e) {
					AsteriskExt.logmessage(1,"Error removing observers");
				}
			}
	
		},

		/******************************************************************************/
		/* Functions                                                                  */
		/******************************************************************************/

		// auto-migration function
		updatePrefs: function ()
		{
			var chan = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.channel");

			// transform channel=SIP/5555 into channel=SIP extension=5555
			var pos = chan.indexOf("/");
			if( (0 < pos) && (pos < chan.length) )
			{
				var c = chan.substr(0, pos);
				var e = chan.substr(pos+1, chan.length - pos)
				AsteriskExt.logmessage(2, "old channel pref:"+chan);
				AsteriskExt.logmessage(2, "new channel pref:"+c);
				AsteriskExt.logmessage(2, "new extension pref:"+e);
				AsteriskExtChrome.ps.setCharPref("extensions.asterisk.channel", c);
				AsteriskExtChrome.ps.setCharPref("extensions.asterisk.extension", e);
			}

			var pass = null;
			try {
				pass = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.password");
			}
			catch(e)
			{
			}

			if( pass != null )
			{
				AsteriskExt.logmessage(2, "Inserting saved password into password manager");
				var user = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.username");
				var myLoginManager = Cc["@mozilla.org/login-manager;1"]
					.getService(Ci.nsILoginManager);

				var nsLoginInfo = new Components.Constructor(
					"@mozilla.org/login-manager/loginInfo;1",  
					Ci.nsILoginInfo, "init"); 
				var loginInfo = new nsLoginInfo('chrome://asterisk-ext',
					null, 'Asterisk Manager User',
					user, pass, "", "");

				try
				{
					myLoginManager.addLogin(loginInfo);
				}
				catch (e)
				{
					AsteriskExt.logmessage(2, "login already exists: "+e);
				}
				AsteriskExtChrome.ps.clearUserPref("extensions.asterisk.password");
			}
		},

		connectManager: function()
		{
			AsteriskExt.logmessage(2, "CALLED: connectManager");
		
			if( ! AsteriskExtChrome.manager.isConnected() )
			{
				var hostname = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.host");
				var port = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.port");
				var channel = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.channel");
				var extension = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.extension");

				var username = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.username");
				var password;  

				try {
					// Get Login Manager
					var myLoginManager = Cc["@mozilla.org/login-manager;1"].
						getService(Ci.nsILoginManager);

					// Find users for the given parameters
					var logins = myLoginManager.findLogins({}, 'chrome://asterisk-ext', null, 'Asterisk Manager User');

					// Find user from returned array of nsILoginInfo objects
					for (var i = 0; i < logins.length; i++)
					{
						if (logins[i].username == username)
						{
							password = logins[i].password;
							break;
						}
					}
				}
				catch(ex) {  
					// This will only happen if there is no nsILoginManager component class  
				}  
				if( AsteriskExtChrome.manager.open(hostname, port) )
				{
					if( ! AsteriskExtChrome.manager.isLoggedIn() )
					{
						AsteriskExtChrome.manager.login(username, ""+password, null);
						AsteriskExtChrome.manager.setChannel(channel, extension);
					}
				}
				else
				{
					AsteriskExt.logmessage(2, "Cannot connect to Asterisk server");
				}
			}
			else
			{
				AsteriskExt.logmessage(1, "Manager already connected");
				document.getElementById("asterisk-ext-status-icon").setAttribute("class", "ok");
			}
		},

		disconnectManager: function()
		{
			AsteriskExt.logmessage(2, "CALLED: disconnectManager");
			if( AsteriskExtChrome.manager.isLoggedIn() )
			{
				AsteriskExtChrome.manager.logout();			
				//AsteriskExtChrome.manager.close();
			}
		},

		/*******************************************************************************
		 * Dial Functions
		 ******************************************************************************/


		dial: function(phonenumber)
		{
			AsteriskExt.logmessage(1, "trying to call:"+phonenumber);
			if( phonenumber.length == 0 ) return;
			var prefix = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.prefix");
			var context = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.context");
			var channel = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.channel");
			var extension = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.extension");

			var priority = "1";
			var callerid = phonenumber;

			AsteriskExtChrome.manager.originate(channel, extension, prefix+phonenumber, context, null);
		},


		cleanPhoneNumber: function(phoneNum)
		{
			var number_a = phoneNum.match(AsteriskExtChrome.numberRegEx);
			if( !number_a ) return "";
			var number = number_a[0];

			number = number.replace(/[^0-9+]+/g,"");
	
			var countrycode = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.countrycode");
			var nationalprefix = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.nationalprefix");
			var internationalprefix = AsteriskExtChrome.ps.getCharPref("extensions.asterisk.internationalprefix");
			var cclen = countrycode.length;
	
			var len = number.length;
	
			if( number.substr(0,1) == "+" )
			{
				if( number.substr(1,cclen) == countrycode )
				{
					number = nationalprefix + number.substr(cclen+1, len-cclen-1);
				}
				else
				{	// problème si le code pays tiens sur 3 numéros
					number = internationalprefix + number.substr(1,len-1);
				}
			}
	
			return number;
		},

	}
}

//if( window.getBrowser ) window.getBrowser().addEventListener("load", AsteriskExtChrome.BrowserOverlay.load, true);
window.addEventListener("load", AsteriskExtChrome.BrowserOverlay.load, true);


